package com.inca.npbusi.saset.bms_sa_bill;

package .tmp;

import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CDetailModel;
import com.inca.np.gui.mde.CMdeModel;
import com.inca.np.gui.ste.CSteModel;
import com.inca.np.util.DecimalHelper;
import java.awt.HeadlessException;

public class Bms_sa_bill_detail extends CDetailModel {
  public Bms_sa_bill_detail(CFrame frame, CMdeModel mdemodel) throws HeadlessException {
    super(frame, "发票细单", mdemodel);
  }
  
  public String getTablename() {
    return "bms_bill_dtl_v";
  }
  
  public String getSaveCommandString() {
    return null;
  }
  
  public void gensarecdtl(DBTableModel hovmodel, int[] rows) {
    DBTableModel dtlmodel = getDBtableModel();
    for (int i = 0; i < rows.length; i++) {
      String thistickmoney = hovmodel.getItemValue(rows[i], 
          "thistickmoney");
      if (thistickmoney != null && !thistickmoney.equals("") && 
        !thistickmoney.equals("0") && 
        !thistickmoney.equals("0.00")) {
        int newrow = dtlmodel.getRowCount();
        dtlmodel.appendRow();
        dtlmodel.setItemValue(newrow, "goodsid", 
            hovmodel.getItemValue(rows[i], "goodsid"));
        dtlmodel.setItemValue(newrow, "goodsname", 
            hovmodel.getItemValue(rows[i], "goodsname"));
        dtlmodel.setItemValue(newrow, "goodstype", 
            hovmodel.getItemValue(rows[i], "goodstype"));
        dtlmodel.setItemValue(newrow, "goodsunit", 
            hovmodel.getItemValue(rows[i], "goodsunit"));
        dtlmodel.setItemValue(newrow, "goodsqty", hovmodel.getItemValue(rows[i], "thistickqty"));
        dtlmodel.setItemValue(newrow, "invogoodsqty", hovmodel.getItemValue(rows[i], "thistickqty"));
        dtlmodel.setItemValue(newrow, "unitprice", 
            hovmodel.getItemValue(rows[i], "unitprice"));
        dtlmodel.setItemValue(newrow, "total_line", hovmodel.getItemValue(rows[i], "thistickmoney"));
        dtlmodel.setItemValue(newrow, "sasettledtlid", 
            hovmodel.getItemValue(rows[i], "sasettledtlid"));
        dtlmodel.setItemValue(newrow, "sasettleid", 
            hovmodel.getItemValue(rows[i], "sasettleid"));
        dtlmodel.setItemValue(newrow, "taxflag", "0");
        dtlmodel.setItemValue(newrow, "salerid", 
            hovmodel.getItemValue(rows[i], "salerid"));
        String linecode = hovmodel.getItemValue(rows[i], "linecode");
        dtlmodel.setItemValue(newrow, "linecode", linecode);
        dtlmodel.setItemValue(newrow, "salername", 
            hovmodel.getItemValue(rows[i], "salername"));
        dtlmodel.setItemValue(newrow, "salesdeptid", 
            hovmodel.getItemValue(rows[i], "salesdeptid"));
        dtlmodel.setItemValue(newrow, "salesdeptname", 
            hovmodel.getItemValue(rows[i], "salesdeptname"));
        dtlmodel.setItemValue(newrow, "taxrate", 
            hovmodel.getItemValue(rows[i], "taxrate"));
        dtlmodel.setItemValue(newrow, "taxmoney", 
            hovmodel.getItemValue(rows[i], "taxmoney"));
        dtlmodel.setItemValue(newrow, "notaxmoney", 
            hovmodel.getItemValue(rows[i], "notaxmoney"));
        on_itemvaluechange(newrow, "total_line", hovmodel.getItemValue(rows[i], "thistickmoney"));
      } 
    } 
    tableChanged();
  }
  
  public void gensarecinvoicedtl(DBTableModel hovmodel, int[] rows, CSteModel cstemodel) {
    DBTableModel dtlmodel = getDBtableModel();
    for (int i = 0; i < rows.length; i++) {
      cstemodel.setItemValue(cstemodel.getRow(), "oriinvcode", hovmodel.getItemValue(rows[i], "billcode"));
      cstemodel.setItemValue(cstemodel.getRow(), "oriinvno", hovmodel.getItemValue(rows[i], "billno"));
      String jsinvdate = hovmodel.getItemValue(rows[i], "jsinvdate");
      String jsinv = jsinvdate.split(" ")[0].replace("-", "");
      cstemodel.setItemValue(cstemodel.getRow(), "blueinvdate", jsinv);
      int newrow = dtlmodel.getRowCount();
      dtlmodel.appendRow();
      dtlmodel.setItemValue(newrow, "goodsid", hovmodel.getItemValue(rows[i], "goodsid"));
      dtlmodel.setItemValue(newrow, "goodsname", hovmodel.getItemValue(rows[i], "goodsname"));
      dtlmodel.setItemValue(newrow, "goodstype", 
          hovmodel.getItemValue(rows[i], "goodstype"));
      dtlmodel.setItemValue(newrow, "goodsunit", 
          hovmodel.getItemValue(rows[i], "goodsunit"));
      dtlmodel.setItemValue(newrow, "goodsqty", hovmodel.getItemValue(rows[i], "goodsqty"));
      dtlmodel.setItemValue(newrow, "invogoodsqty", "-" + hovmodel.getItemValue(rows[i], "goodsqty"));
      dtlmodel.setItemValue(newrow, "unitprice", 
          hovmodel.getItemValue(rows[i], "unitprice"));
      dtlmodel.setItemValue(newrow, "total_line", 
          hovmodel.getItemValue(rows[i], "total_line"));
      dtlmodel.setItemValue(newrow, "sasettledtlid", 
          hovmodel.getItemValue(rows[i], "sasettledtlid"));
      dtlmodel.setItemValue(newrow, "sasettleid", 
          hovmodel.getItemValue(rows[i], "sasettleid"));
      dtlmodel.setItemValue(newrow, "taxflag", "0");
      dtlmodel.setItemValue(newrow, "salerid", 
          hovmodel.getItemValue(rows[i], "salerid"));
      String linecode = hovmodel.getItemValue(rows[i], "linecode");
      dtlmodel.setItemValue(newrow, "linecode", linecode);
      dtlmodel.setItemValue(newrow, "salername", 
          hovmodel.getItemValue(rows[i], "salername"));
      dtlmodel.setItemValue(newrow, "salesdeptid", 
          hovmodel.getItemValue(rows[i], "salesdeptid"));
      dtlmodel.setItemValue(newrow, "salesdeptname", 
          hovmodel.getItemValue(rows[i], "salesdeptname"));
      dtlmodel.setItemValue(newrow, "taxrate", 
          hovmodel.getItemValue(rows[i], "taxrate"));
      dtlmodel.setItemValue(newrow, "taxmoney", 
          hovmodel.getItemValue(rows[i], "taxmoney"));
      dtlmodel.setItemValue(newrow, "notaxmoney", 
          hovmodel.getItemValue(rows[i], "notaxmoney"));
    } 
    tableChanged();
  }
  
  protected int on_beforedel(int row) {
    String usestatus = this.mdemodel.getMasterModel().getItemValue(
        this.mdemodel.getMasterModel().getRow(), "usestatus");
    if ("1".equals(usestatus)) {
      infoMessage("提示", "总单为正式状态，不能删除！");
      return -1;
    } 
    if ("0".equals(usestatus)) {
      infoMessage("提示", "总单为作废状态，不能删除！");
      return -1;
    } 
    return super.on_beforedel(row);
  }
  
  protected int on_beforemodify(int row) {
    String usestatus = this.mdemodel.getMasterModel().getItemValue(
        this.mdemodel.getMasterModel().getRow(), "usestatus");
    if ("1".equals(usestatus))
      return -1; 
    if ("0".equals(usestatus))
      return -1; 
    return super.on_beforemodify(row);
  }
  
  protected void on_itemvaluechange(int row, String colname, String value) {
    if (colname.equals("taxmoney")) {
      String total_line = getItemValue(row, "total_line");
      String notaxmoney = DecimalHelper.sub(total_line, value, 2);
      setItemValue(row, "notaxmoney", notaxmoney);
    } else if (colname.equals("notaxmoney")) {
      String total_line = getItemValue(row, "total_line");
      String taxmoney = DecimalHelper.sub(total_line, value, 2);
      setItemValue(row, "taxmoney", taxmoney);
    } 
    super.on_itemvaluechange(row, colname, value);
  }
}
